<?xml version="1.0" encoding="utf-8"?>
<transform xmlns="http://www.w3.org/1999/XSL/Transform" xmlns:dp="http://swsoft.com/Plesk/dashboard-preset" xmlns:str="http://exslt.org/strings" version="1.0">
  <output method="text"/>
  <template match="dp:preset">
	<if test="count(screen) > 1">
	  <message terminate="yes">Only one screen is supported at this time.</message>
	</if>
	<apply-templates select="*"/>
  </template>
  <template match="dp:screen">
	<choose>
	  <when test="@uri='/plesk/dashboard/' and ../@type='admin'"/>
	  <when test="@uri='/plesk/client@/dashboard/' and ../@type='client'"/>
	  <when test="@uri='/plesk/client@/domain@/dashboard/' and ../@type='domain'"/>
	  <otherwise>
		<message terminate="yes">Invalid combination of preset type and screen URI</message>
	  </otherwise>
	</choose>

	<text>set @preset_id = NULL</text>
	<call-template name="newline"/>

	<text>select @preset_id:=id from DashboardPreset where name = '</text>
	<call-template name="mysql-escape"><with-param name="text" select="../@name"/></call-template>
	<text>' and type = '</text>
	<value-of select="../@type"/>
	<text>'</text>
	<call-template name="newline"/>

	<text>replace into DashboardPreset (id, name, uri, type) values (@preset_id, '</text>
	<call-template name="mysql-escape"><with-param name="text" select="../@name"/></call-template>
	<text>', '</text>
	<call-template name="mysql-escape"><with-param name="text" select="@uri"/></call-template>
	<text>', '</text>
	<value-of select="../@type"/>
	<text>')</text>
	<call-template name="newline"/>

	<text>select @preset_id:=id from DashboardPreset where name = '</text>
	<call-template name="mysql-escape"><with-param name="text" select="../@name"/></call-template>
	<text>' and type = '</text>
	<value-of select="../@type"/>
	<text>'</text>
	<call-template name="newline"/>

	<text>delete from DashboardPresetConfig where preset_id = @preset_id</text>
	<call-template name="newline"/>

	<apply-templates select="*"/>
  </template>
  <template match="dp:element">
	<text>insert into DashboardPresetConfig (preset_id, ord, uri, parent_id, type, title, description, enabled) values (@preset_id, </text>
	<value-of select="count(../dp:element) - position()"/>
	<text>, '</text>
	<call-template name="mysql-escape"><with-param name="text" select="@uri"/></call-template>
	<text>', </text>
	<choose>
	  <when test="parent::dp:screen">
		<text>null</text>
	  </when>
	  <otherwise>
		<text>@id</text>
		<value-of select="count(ancestor::dp:element)"/>
	  </otherwise>
	</choose>
	<text>, '</text>
	<value-of select="@type"/>
	<text>', </text>
	<choose>
	  <when test="@title">
		<text>'</text>
		<call-template name="mysql-escape"><with-param name="text" select="@title"/></call-template>
		<text>'</text>
	  </when>
	  <otherwise>
		<text>null</text>
	  </otherwise>
	</choose>
	<text>, </text>
	<choose>
	  <when test="@description">
		<text>'</text>
		<call-template name="mysql-escape"><with-param name="text" select="@description"/></call-template>
		<text>'</text>
	  </when>
	  <otherwise>
		<text>null</text>
	  </otherwise>
	</choose>
	<text>, '</text>
	<value-of select="@enabled"/>
	<text>')</text>
	<call-template name="newline"/>

	<if test="dp:element">
	  <text>set @id</text>
	  <value-of select="count(ancestor-or-self::dp:element)"/>
	  <text>:=last_insert_id()</text>
	  <call-template name="newline"/>
	</if>

	<apply-templates select="*"/>
  </template>
  <template match="text()"/>
  <template name="mysql-escape">
	<param name="text"/>
	<for-each select="str:split(string($text), '')">
		<if test=".=&quot;'&quot; or .='\'">\</if>
		<value-of select="."/>
	</for-each>
  </template>
  <template name="newline">
	<text>;
</text>
  </template>
</transform>
